/*  libbadpenguin -- generic library for Bad Penguin development
 *
 *  Copyright (C) 1996 Antonio Gallo
 *  agx@linux.it
 *  
 *  Newer versions should be on www.badpenguin.org
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 */

#include <sys/wait.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#define __USE_GNU
#include <unistd.h>

// Run a command (you should specify each options) without
// using the shell, you should open file to redirect the output
int runcommand (char *options[], int fdin, int fdout, int fderr ) {
  int pid, status;
  pid = fork();
  if (pid == -1) return -1;
  if (pid == 0) {

    if (fdin>0) dup2( fdin, STDIN_FILENO ); else
    if (fdin<0) fclose(stdin);    

    if (fdout>0) dup2( fdout, STDOUT_FILENO ); else
    if (fdout<0) fclose(stdout);    

    if (fderr>0) dup2( fderr, STDERR_FILENO ); else
    if (fderr<0) fclose(stderr);

    execvp(options[0], options);
    exit(127);
  }
  do {
    if (waitpid(pid, &status, 0) == -1) {
      if (errno != EINTR) return -1;
    } else {
//      if (fdin!=0) close( fdin );
//      if (fdout!=0) close( fdout );      
      return status;
    }
    sleep(1);
  } while(1);
}

